#ifndef  _SMAGE_COMIC_ELLIPSE_SHAPE_H
#define  _SMAGE_COMIC_ELLIPSE_SHAPE_H

#include "SmageEllipseShape.h"

/** Structure for think-bubble's circles
  *
  * @ingroup LibSmage
  *
  */
struct SmageThinkBubbleCircle {
  SmageThinkBubbleCircle();          // Constructor
  QPoint pos;                        // Position of the circle
  QSize size;                        // Circle's size
};

/** Structure for comic ellipse shape items.
  *
  * @ingroup LibSmage
  *
  */
struct SmageComicEllipseObj {
  SmageComicEllipseObj();            // Constructor
  SmageEllipseObj ellipseObjData;    // Data from parent class
  QPoint bubblePeakPos;              // If speech bubble, position for triangle's peak
  int openAngle;                     // Angles for speech bubble's opening
  int closeAngle;
  std::vector<SmageThinkBubbleCircle> thinkBubbleCircles; // Circles connecting bubble and subject
};


class SmageComicEllipseShape : public SmageEllipseShape
{
  public:
    /** Constructor.
      */
    SmageComicEllipseShape();
      
    /** Destructor.
      */
    ~SmageComicEllipseShape();

    void setComicEllipseObject(const SmageComicEllipseObj *obj);
    void generateComicEllipseShapeString();

    bool getComicEllipseShapeObjects(const std::vector<char> &charVec);
    bool getComicEllipseShapeObject(const std::vector<char> &charVec, std::vector<char>::const_iterator &charVecIter,
				    SmageComicEllipseObj *obj);

    void printDebugInfos(const SmageComicEllipseObj *obj);

    const std::vector<SmageComicEllipseObj *> getObjVec() { return _comicEllipseObjVec; }

  protected:
      
    std::vector<SmageComicEllipseObj *> _comicEllipseObjVec;
};

#endif
