#ifndef  _SMAGE_ELLIPSE_SHAPE_H
#define  _SMAGE_ELLIPSE_SHAPE_H

#include "SmageTextShape.h"

#include <qrect.h>

#include <iostream.h>

/** Structure for ellipse shape items .
  *
  * @ingroup LibSmage
  *
  */
struct SmageEllipseObj {
  SmageEllipseObj();                // Constructor
  SmageTextObj textObjData;         // Data from parent class
  QRect ellipseShapeRect;           // Rectangle that defines the ellipse
};


class SmageEllipseShape : public SmageTextShape
{
  public:
    /** Constructor.
      */
    SmageEllipseShape();
      
    /** Destructor.
      */
    ~SmageEllipseShape();

    void setEllipseObject(const SmageEllipseObj *obj);
    void generateEllipseShapeString();
    
    bool getEllipseShapeObjects(const std::vector<char> &charVec);
    bool getEllipseShapeObject(const std::vector<char> &charVec, std::vector<char>::const_iterator &charVecIter, 
			       SmageEllipseObj *obj);
    void printDebugInfos(const SmageEllipseObj *obj);

    const std::vector<SmageEllipseObj *> getObjVec(){ return _ellipseObjVec; }

  protected:
    void getEllipseShapeString(std::vector<char> &charVec, SmageEllipseObj *ellipseObj, unsigned int &stringSize);

    std::vector<SmageEllipseObj *> _ellipseObjVec;
};

#endif
