/** This class provides logging of debug information.
  *
  * @ingroup LibSmage
  *
  */

#ifndef SMAGE_LOG_H
#define SMAGE_LOG_H

#include <stdio.h>
#include <stdarg.h>
#include <string.h>

class SmageLog
{
  public:
    /** Construktor.
      */
    SmageLog(char *path);
    
    /** Destructor.
      */
    ~SmageLog();
  
    /** Print debug information.
      */
    void lprintf(char *text,...);
  
  private:
    /** Opens log file.
      */
    void open() { if (!logFile) logFile = fopen(filePath,"a"); };
  
    /** Closes log file.
      */
    void close() { if (logFile!=NULL) { fclose(logFile); logFile = NULL; } }; 

  public:
    /**
      */
    char *filePath;
    
    /**
      */ 
    FILE *logFile;
};

#endif
