#include "NPSmagePlugin.h"
#include "NPSmagePluginInstance.h"
#include "../smageSharedFiles/SmageXmlConfigFileParser.h"

QNPlugin*
QNPlugin::create()
{
  // get users program configuration
  SmageXmlConfigFileParser configFileParser;
  return new NPSmagePlugin();
}

QNPInstance*
NPSmagePlugin::newInstance()
{
  return new NPSmagePluginInstance();
}

const char* 
NPSmagePlugin::getMIMEDescription() const
{
  return "application/smage:bmp:BMP Image,"
         "application/smage:jpeg:JPEG Image,"
         "application/smage:png:PNG Image";
}

const char*
NPSmagePlugin::getPluginNameString() const
{
  return "Smage Plugin";
}

const char*
NPSmagePlugin::getPluginDescriptionString() const
{
  return "Smage Plugin, version 2005-03-01. A plugin for displaying and interacting with annotated bitmaps. Written by Lothar Schlesier and Henry Sonnet. For further information go to <a href=\"http://www.smage.de\">Smage.de</a>";
}
