// project header
#include "NPSmagePluginWidget.h"
#include "NPSmagePluginInstance.h"

#include <qapplication.h>

//file://localhost/C:/Qt/3.2.0Educational/doc/html/qt.html#WidgetFlags-enum
NPSmagePluginWidget::NPSmagePluginWidget() : QNPWidget( /*0,0, 0Qt::WType_TopLevel | Qt::WStyle_Customize | Qt::WStyle_NoBorder*/ )
{
  _error = FALSE;
  _layout = new QGridLayout( this );

    _spw = new SmageNPPluginViewerWidget( this );
  _layout->addMultiCellWidget( _spw, 0, 0, 0, 1 );
  _layout->setRowStretch ( 0, 100 );

    _status1 = new QLabel( "", this );
  _layout->addMultiCellWidget( _status1, 1, 1, 0, 1 );
  _layout->setRowStretch ( 1, 1 );

    _status2 = new QLabel( "", this );
  _layout->addWidget( _status2, 2, 0 );
    _prog =0;
    _progress = new QProgressBar( 0, this );
    _progress->setCenterIndicator( TRUE );
  _layout->addWidget( _progress, 2, 1 );
  _layout->setRowStretch ( 2, 1 );
}

NPSmagePluginWidget::~NPSmagePluginWidget()
{
}

void
NPSmagePluginWidget::enterInstance()
{
  // show link location in the status bar of the webbrowser while mouse is
  // over the plugin
  NPSmagePluginInstance *plugin = (NPSmagePluginInstance*)instance();
  if ( plugin->hasRefURL() ) plugin->status( plugin->getAbsRefURL() );
  repaint( TRUE );
}

void
NPSmagePluginWidget::leaveInstance()
{
  // clear the browsers status bar
  NPSmagePluginInstance *plugin = (NPSmagePluginInstance*)instance();
  if ( plugin->hasRefURL() ) plugin->status( "" );
  repaint( TRUE );
}

void
NPSmagePluginWidget::paintEvent( QPaintEvent *e )
{
  if ( _error )
  {
    QPainter p( this );
    p.drawText( width()/8, 0, width()-width()/4, height(), AlignCenter|WordBreak, "An Error occured" );
  }
}

void
NPSmagePluginWidget::mousePressEvent( QMouseEvent *e )
{
  if ( _error )
  {
    NPSmagePluginInstance *plugin = (NPSmagePluginInstance*)instance();
    plugin->visitLinkLocation();
  }
}
