/** The NPSmagePluginWidget class provides a QWidget that is a Web-browser plugin window.
  *
  * @ingroup NPSmagePlugin
  *
  */
#ifndef NP_SMAGE_PLUGIN_WIDGET_H
#define NP_SMAGE_PLUGIN_WIDGET_H

// project header
#include "SmageNPPluginViewerWidget.h"

// qt header
#include "qnp.h"
#include <qlabel.h>
#include <qprogressbar.h>

class NPSmagePluginWidget : public QNPWidget
{
  Q_OBJECT
  
  public:

    /** Constructor.
      */
    NPSmagePluginWidget();

    /** Destructor.
      */
    ~NPSmagePluginWidget();
    
    /**
      */
    void enterInstance();

    /**
      */
    void leaveInstance();

    /**
      */
    SmageNPPluginViewerWidget *_spw;

    /**
      */
    QGridLayout *_layout;

    /**
      */
    QLabel *_status1;

    /**
      */
    QLabel *_status2;

    /** Shows the progress of the dwnload of the image.
      * @see _prog
      */
    QProgressBar *_progress;

    /**
      */
    int _prog;
    
    /**
      */
    bool _error;
    
  protected:
    /** Event handler for mouse press events.
      * 
      * @see _error
      */
    virtual void mousePressEvent( QMouseEvent *e );

    /**
      */
    virtual void paintEvent( QPaintEvent *e);

};

#endif //NP_SMAGE_PLUGIN_WIDGET_H
