/** A class for decoding images.
  *
  * @ingroup SmageApp
  * @ingroup NPSmagePlugin
  * @ingroup SmageAXPlugin
  *
  * This class provides wrapper functions for the decoding of images.
  */
#ifndef SMAGE_DOCODE_HANDLER
#define SMAGE_DOCODE_HANDLER

// project header
#include "SmageViewerWidget.h"
#include "SmageXmlLanguageFileParser.h"
#include "structs/SmageStructDecodedData.h"
#include "structs/SmageStructDecodeInfo.h"
#include "structs/TheS_DictEntries.h"
#include <SmageComicEllipseShape.h>
#include <SmageImgLSBsDecoder.h>

// c/c++ header
#include <map>
#include <vector>

class SmageDecodeHandler
{
  public:
    /** Decodes an image.
      * Decodes the image, writes 
      */
    static SmageStructDecodeInfo decode( QImage image, QImage &refIDBuffer, QImage &outlineImg, std::map<unsigned int, SmageStructDecodedData> &decodedDataMap, SmageViewerWidget *parent );
    
    static bool getDictEntries(const QString &text, QString &codedTerm, DictEntriesPair &dictEntries);
    
    static QPopupMenu* createDictMenu(std::vector<TheS_Language> *languages, QWidget *parent, QButtonGroup *&fromGroup, QButtonGroup *&toGroup);
};

#endif // SMAGE_DOCODE_HANDLER
