/** The base class for formatted text widgets (Speech bubble, ...)
  *
  * @ingroup SmageApp
  * @ingroup NPSmagePlugin
  * @ingroup SmageAXPlugin
  *
  */
#ifndef _SMAGE_VIEWER_SHAPED_TEXT_
#define _SMAGE_VIEWER_SHAPED_TEXT_

// project header
#include "SmageShapedTextBase.h"
#include "structs/TheS_BubbleData.h"

// qt header
#include <qbitmap.h>


class SmageViewerShapedText : public SmageShapedTextBase
{
  Q_OBJECT

  public:
    SmageViewerShapedText(QWidget *parent, const char* name);
    ~SmageViewerShapedText();
    void scaleBubble( float xScale, float yScale);
    virtual QString getClassName() = 0;  

    TheS_BubbleData _bubbleData;
    QPixmap _normal, _outlined;
    QBitmap _mask;

  protected:
    virtual void mouseMoveEvent( QMouseEvent *e );
    virtual void mousePressEvent( QMouseEvent *e );
    
    void initBubble();
    virtual void preparePixmaps() = 0;
    QPoint _textPosition;
};

#endif
