#ifndef _SMAGE_VIEWER_SPEECH_BUBBLE_H
#define _SMAGE_VIEWER_SPEECH_BUBBLE_H

// project header
#include "SmageViewerShapedText.h"
#include <SmageComicEllipseShape.h>

// qt header
#include <qbitmap.h>
#include <qpointarray.h>

/** Widget class that displays a speech bubble.
  *
  * @ingroup SmageApp
  * @ingroup NPSmagePlugin
  * @ingroup SmageAXPlugin
  *
  */
class SmageViewerSpeechBubble : public SmageViewerShapedText
{
  Q_OBJECT

  public:
    SmageViewerSpeechBubble(QWidget *parent, const char* name, const SmageComicEllipseObj &ellipseObj);
    virtual QString getClassName() { return QString("SmageViewerSpeechBubble"); }
    ~SmageViewerSpeechBubble();

  protected:
    void preparePixmaps();

    QPoint _bubblePeakPos;
    QRect _ellipseRect;

    double _openAngle, _closeAngle;
};

#endif
