// project header
#include "SmageConfig.h"
#include "SmageXmlConfigFileParser.h"

// qt header
#include <qfile.h>
#include <qstring.h>

// c/c++ header
#include <iostream>

SmageConfig __smageConfig;

SmageConfig::SmageConfig()
{
  _loaded = FALSE;
  _language = "en";
}

SmageXmlConfigFileParser::SmageXmlConfigFileParser() : QXmlDefaultHandler()
{
#ifdef THE_S_PRINT_DEBUG
  _TheSmageLogFile.lprintf("SmageXmlConfigFileParser::SmageXmlConfigFileParser()\n");
#endif
  if (__smageConfig._loaded) return;
  init();
}

SmageXmlConfigFileParser::~SmageXmlConfigFileParser()
{
#ifdef THE_S_PRINT_DEBUG
  _TheSmageLogFile.lprintf("SmageXmlConfigFileParser::SmageXmlConfigFileParser()\n");
#endif  
}

void
SmageXmlConfigFileParser::init()
{
  char *d = getenv("SMAGE_DIR");
  QString smageDir ="";
  if ( d != NULL ) smageDir = QString( d );
  QString fileName("smageConfig.xml");
  QFile xmlFile( smageDir + fileName);
  QXmlInputSource source(&xmlFile);
  QXmlSimpleReader reader;
  reader.setContentHandler(this);
  reader.parse(source);
  _status = -1;
  __smageConfig._loaded = TRUE;
}

bool
SmageXmlConfigFileParser::startDocument()
{
  return TRUE;
}

bool
SmageXmlConfigFileParser::startElement(const QString&, const QString&, const QString& tagName, const QXmlAttributes&)
{
  if ( tagName.lower() == QString("language") )
  {
    _status = 1;
  }
  return TRUE;
}

bool
SmageXmlConfigFileParser::endElement(const QString&, const QString&, const QString& tagName)
{
  _status--;
  return TRUE;
}

bool
SmageXmlConfigFileParser::characters(const QString &data)
{
  switch (_status)
  {
    case 1: __smageConfig._language = data; break;
  }
  return TRUE;
}
