// project header
#include "SmageConfig.h"
#include "SmageXmlConfigFileParser.h"
#include "SmageXmlLanguageFileParser.h"

// qt header
#include <qfile.h>
#include <qstring.h>

// c/c++ header
#include <iostream>

std::vector<TheS_Language> __languagesVec;
extern SmageConfig __smageConfig;


SmageXmlLanguageFileParser::SmageXmlLanguageFileParser() : QXmlDefaultHandler()
{
#ifdef THE_S_PRINT_DEBUG
  _TheSmageLogFile.lprintf("SmageXmlLanguageFileParser::SmageXmlLanguageFileParser()\n");
#endif
  if (__languagesVec.size() > 0) return;
  init();
}

SmageXmlLanguageFileParser::~SmageXmlLanguageFileParser()
{
#ifdef THE_S_PRINT_DEBUG
  _TheSmageLogFile.lprintf("SmageXmlLanguageFileParser::~SmageXmlLanguageFileParser()\n");
#endif  
}

void
SmageXmlLanguageFileParser::init()
{
  char *d = getenv("SMAGE_DIR");
  QString smageDir ="";
  if ( d != NULL ) smageDir = QString( d );
  QString fileName("smageLanguages_"+ __smageConfig._language+".xml");
  QFile xmlFile( smageDir + fileName);
  QXmlInputSource source(&xmlFile);
  QXmlSimpleReader reader;
  reader.setContentHandler(this);
  reader.parse(source);
  _status = -1;
}

bool
SmageXmlLanguageFileParser::startDocument()
{
  return TRUE;
}

bool
SmageXmlLanguageFileParser::startElement(const QString&, const QString&, const QString& tagName, const QXmlAttributes&)
{
  if ( tagName.lower() == QString("language") )
  {
    _status = 1;
  }
  else if ( tagName.lower() == QString("tag") )
  {
    _status = 2;
  }
  return TRUE;
}

bool
SmageXmlLanguageFileParser::endElement(const QString&, const QString&, const QString& tagName)
{
  _status--;
  if ( _status == 0)
  {
    __languagesVec.push_back( _currentLang );
  }
  return TRUE;
}

bool
SmageXmlLanguageFileParser::characters(const QString &data)
{
  switch (_status)
  {
    case 1: _currentLang._name = data; break;
    case 2: _currentLang._tag = data; break;
//    default: return FALSE;
  }
  return TRUE;
}
