#ifndef _SMAGE_DICT_EDITOR_H
#define _SMAGE_DICT_EDITOR_H

// project header
#include "SmageXmlHandler.h"

// qt header
#include <qdialog.h>
class QLabel;
class QLineEdit;

// c/c++ header
#include <vector>

class SmageDictEditor : public QDialog
{
  Q_OBJECT

 public:

  SmageDictEditor(QWidget *parent, const char* name, const char *xmlFileName);
  ~SmageDictEditor();

  static bool getNewDictEntries(const char *xmlFileName, QString &idString, QString &entry, 
				int &language, QWidget *parent = 0);

 public slots:
   void okPressed();
   void cancelPressed();

 private:

   bool getFirstEntry(QString &entry, int &language);

  void initSubWidgets();
  bool appendEntry();
  void resetFields();
  
  QLineEdit *_lineEng;
  std::vector<QLineEdit*>_lineEdits;
  SmageXmlHandler *_xmlHandler;
};

#endif
