#ifndef _SMAGE_DICT_ENTRY_DLG_H
#define _SMAGE_DICT_ENTRY_DLG_H

// project header
#include "../smageSharedFiles/SmageConfig.h"
#include "../smageSharedFiles/structs/TheS_DictEntries.h"

// qt header
#include <qdialog.h>
class QComboBox;
class QLineEdit;

/** Class SmageDictEntryDlg: Dialog in which a user can enter a dictionary entry.
  *
  * @ingroup SmageApp
  *
  */
class SmageDictEntryDlg : public QDialog
{
  Q_OBJECT

 public:

    SmageDictEntryDlg(QWidget *topLevel=0);
    ~SmageDictEntryDlg();

    // Open the dialog and get the user input
    static bool getDictEntry(int &language, QString &entry, QWidget *parent = 0);
    
  public slots:
    void okPressed();
    void cancelPressed();
    void chosenLang(int lang);

 private:
    
    void setLang(const int &lang);

    QLineEdit *_enterTerm;
    QComboBox *_langsCombo;
    int _language;
};

#endif
