/** The base class for formatted text widgets (Speech bubble, ...)
  *
  * @ingroup SmageApp
  *
  */
#ifndef _SMAGE_EDITOR_SHAPED_TEXT_H
#define _SMAGE_EDITOR_SHAPED_TEXT_H

// project header
#include "SmageBubbleText.h"
#include "SmageTextEditor.h"
#include "../smageSharedFiles/SmageShapedTextBase.h"
#include "../smageSharedFiles/structs/TheS_BubbleData.h"

// qt header
#include <qcursor.h>
#include <qpopupmenu.h>

class SmageEditorShapedText : public SmageShapedTextBase
{
  Q_OBJECT

  public:

    SmageEditorShapedText(QWidget *parent, const char* name);
    ~SmageEditorShapedText();

  protected:
    virtual void mousePressEvent(QMouseEvent *);
    virtual void mouseReleaseEvent(QMouseEvent *);
    virtual void mouseMoveEvent(QMouseEvent *);
    virtual void updateText(const TheS_BubbleData &bubbleData);
    void initContextMenu();
    virtual void calcWidgetMask() = 0;

    QPoint _position, _pressedPos;
    QPopupMenu *_contextMenu;
    
    SmageTextEditor *_bubbleEditor;
    SmageBubbleText *_bubbleText;

    TheS_BubbleData _newBubbleData, _prevBubbleData;

    QBitmap _bubbleMask;


 protected slots:
   void changeProps();
   void deleteElement();
   virtual void moveTextToCenter() = 0;
};

#endif
