#ifndef _SMAGE_EDITOR_SIMPLE_BUBBLE_H
#define _SMAGE_EDITOR_SIMPLE_BUBBLE_H

// project header
#include "SmageEditorShapedText.h"
#include <SmageEllipseShape.h>
class SmageBubble;

/** Widget class that enables a user to create and edit texts within an ellipse or a rectangle.
  *
  * @ingroup SmageApp
  *
  */
class SmageEditorSimpleBubble : public SmageEditorShapedText
{
  Q_OBJECT

 public:
  SmageEditorSimpleBubble(QWidget *parent, const char* name, const TextShapeType &type);

  std::vector<char> getBubbleData(const QPoint &posOffset);
  virtual QString getClassName() { return QString("SmageEditorSimpleBubble"); }

  ~SmageEditorSimpleBubble();


 protected:

  static void bubbleTextMoveCB(void *userData);
  static void bubbleTextMouseReleaseCB(void *userData);
  static void bubbleReleaseCB(void *userData);
  static void bubblePressCB(void *userData, const QMouseEvent *event);
  static void bubbleMoveCB(void *userData);
  static void updateMaskCB(void *userData, const bool &clearMask);
  static void crossingBorderCB(void *userData);
  static void updateBBoxCB(void *userData, const char *name);
  static void previewCB(void *, const TheS_BubbleData &);
  static void okCB(void *, const TheS_BubbleData &);
  static void cancelCB(void *);

  void initClassData();
  void initBubble(const QRect &rect);

  void calcWidgetMask();
  void assignWidgetSize();
  void updateBubble(const TheS_BubbleData &bubbleData);
  void handleCrossingBorder();

  SmageBubble *_bubble;

  TextShapeType _bubbleType;

 protected slots:
   void moveTextToCenter();
};

#endif
