// project header
#include "SmageEncDoneDlg.h"

// qt header
#include <qgroupbox.h>
#include <qfiledialog.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qpushbutton.h>

// c/c++ header
#include <iostream>
#include <stdlib.h>

using namespace std;

SmageEncDoneDlg::SmageEncDoneDlg(QWidget *topLevel)
  : QDialog(topLevel, 0)
{
  setCaption( tr("Image Coding Finished ..."));

  _gridLayout = new QGridLayout(this,3,4,20);

  QLabel *label = new QLabel(this);
  label->setGeometry(10, 30, 400, 150);

  label->setText(QString(tr("Data has been successfully embedded.\nDo you want to save the coded image?")));

  // Save / Cancel button
  _saveButton = new QPushButton(tr("Save"), this);
  connect(_saveButton, SIGNAL(clicked()), this, SLOT(savePressed()));
  _saveButton->setFixedSize(90, 40);
  _saveButton->setDefault(TRUE);

  _cancelButton = new QPushButton(QObject::tr("Cancel"), this);
  connect(_cancelButton, SIGNAL(clicked()), this, SLOT(cancelPressed()));
  _cancelButton->setFixedSize(90, 40);

  _gridLayout->addMultiCellWidget(label, 0, 0, 0, 3, Qt::AlignHCenter);
  _gridLayout->addWidget(_saveButton, 2, 1, Qt::AlignHCenter);  
  _gridLayout->addWidget(_cancelButton, 2, 2, Qt::AlignHCenter);
}


SmageEncDoneDlg::~SmageEncDoneDlg() 
{   
}


void SmageEncDoneDlg::savePressed()
{
  char *d = getenv("SMAGE_DIR");
  QString smageDir ="";
  if ( d != NULL ) smageDir = QString( d + QObject::tr("My Smages") );

  _fileName = QFileDialog::getSaveFileName(smageDir, tr("Images (*.png)"), this, "encSaveFileDlg", tr("Save File"));

  if (!_fileName.isEmpty())
    accept();
  else
    reject();
}


void SmageEncDoneDlg::cancelPressed()
{
  reject();
}


bool SmageEncDoneDlg::getFileName(QString &fileName, QWidget *parent, const char*)
{
  SmageEncDoneDlg *dlg = new SmageEncDoneDlg(parent);
  bool returnValue = FALSE;

  if (dlg->exec() == QDialog::Accepted)
  {
    fileName = dlg->_fileName.ascii();
    returnValue = TRUE;
  }
  
  delete dlg;
  return returnValue;
}
