/** Widget that creates 
  *
  * @ingroup SmageApp
  *
  */

#ifndef SMAGE_HTML_GENERATOR
#define SMAGE_HTML_GENERATOR

// qt header
#include <qcheckbox.h>
#include <qdialog.h>
#include <qlineedit.h>
#include <qtextedit.h>

struct ImageProperties
{
  ImageProperties();
  ImageProperties( QString fN, int w, int h);
  QString _fileName;
  int _width;
  int _height;
};

class SmageHTMLGenerator : public QDialog
{
  Q_OBJECT

  public:
    SmageHTMLGenerator( QWidget *parent = 0, const char *name = 0, bool modal = FALSE, WFlags f = 0 );
    ~SmageHTMLGenerator();
    void setValues( ImageProperties ip );
    
  private slots:
    void updateText();
    void copyToClipboard();
    void activateLink();
    
  private:
    QLineEdit *_fileName;
    QLineEdit *_width;
    QLineEdit *_height;
    QCheckBox *_hasLinkUrl;
    QLineEdit *_linkUrl;
    
    QTextEdit *_htmlSource;
};

#endif
