// project header
#include "SmageHelpBrowser.h"

// qt header
#include <qiconset.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>

#include "./pixmaps/back.xpm"
#include "./pixmaps/forward.xpm"
#include "./pixmaps/home.xpm"

// c/c++ header
#include <assert.h>
#include <iostream>

using namespace std;

SmageHelpBrowser::SmageHelpBrowser(QWidget *parent, const QString &home, const QStringList &path, const char* name)
  : QMainWindow(parent, name)
{ 
#ifdef THE_S_PRINT_DEBUG
  _TheSmageLogFile.lprintf("SmageHelpBrowser::SmageHelpBrowser()\n");
#endif

  setCaption(tr("Smage - Help"));

  _browser = new QTextBrowser(this);
  setCentralWidget(_browser);

  _browser->mimeSourceFactory()->setFilePath(path);
  if (!home.isEmpty())
    _browser->setSource(home);

  initialize();

  _browser->setFocus();
}


SmageHelpBrowser::~SmageHelpBrowser()
{ 
}


void SmageHelpBrowser::initialize()
{
  QIconSet icon_back = QIconSet(QPixmap(back_xpm));
  QIconSet icon_forward = QIconSet(QPixmap(forward_xpm));
  QIconSet icon_home = QIconSet(QPixmap(home_xpm));

  QToolBar* toolbar = new QToolBar(this);
  addToolBar(toolbar, "Toolbar");

  QToolButton *backB = new QToolButton(icon_back, tr("Backward"), "", _browser, SLOT(backward()), toolbar);
  connect(_browser, SIGNAL(backwardAvailable(bool)), backB, SLOT(setEnabled(bool)));
  backB->setEnabled(FALSE);

  QToolButton *forwardB = new QToolButton(icon_forward, tr("Forward"), "", _browser, SLOT(forward()), toolbar);
  connect(_browser, SIGNAL(forwardAvailable(bool)), forwardB, SLOT( setEnabled(bool)));
  forwardB->setEnabled(FALSE);

  QToolButton *homeB = new QToolButton(icon_home, tr("Home"), "", _browser, SLOT(home()), toolbar);
  homeB->setEnabled(TRUE);
}
