#ifndef _SMAGE_IMG_HANDLER_H
#define _SMAGE_IMG_HANDLER_H

#define THE_S_BACKGROUND_COLOR 255,255,255
#define THE_S_FOREGROUND_COLOR 0,0,0

// project header
#include "../smageSharedFiles/SmageConfig.h"

// qt header
#include <qbitmap.h>
#include <qimage.h>
class QPointArray;

/** Class SmageImgHandler for image processing.
  *
  * @ingroup SmageApp
  *
  * - do regions intersect ...
  */
class SmageImgHandler
{
  public:
  
    SmageImgHandler();
    ~SmageImgHandler();

    /**  Do the filled regions in "bitmap" overlap with filled regions in "img"
      */
    static bool regionsDoNotIntersect(QImage &img, const QBitmap &bitmap);
    static bool regionsDoNotIntersect(const QBitmap &bitmap1, const QBitmap &bitmap2);

    // Fill regions of "bitmap" in "img"
    static void fillRegionsInImg(QImage &img, const QBitmap &bitmap);

    // Try to compress the image as much as possible without loss and save it as "fileName"
    static bool saveImgToFile(const QString &fileName, const QImage &img, const QString &fileFormat);

    static bool findOutline(QImage *img, QPointArray &points, const QRgb &color);
    static bool searchForNextOutlinePixel(const QImage *img, QImage &bitmap, const QPoint &curPos, QPoint &nextPos);
    static bool isOutlinePixel(const QImage *img, QImage &bitmap, const QPoint &pos, const QRgb &color);
    static bool areNeighbors(const QPoint &p1, const QPoint &p2);
    static bool compareRgb(const QRgb &c1, const QRgb &c2);
    static bool isVisitedNoneBackAround(const QImage &bitmap, const QPoint &pos);
};

#endif
