#ifndef _SMAGE_IMG_INPUT_DLG_H
#define _SMAGE_IMG_INPUT_DLG_H

// project header
#include "../smageSharedFiles/SmageConfig.h"

// qt header
#include <qdialog.h>
class QGridLayout;
class QGroupBox;
class QLabel;
class QLineEdit;
class QPushButton;
class QTextEdit;

/** Class SmageImgInputDlg Dialog in which a user can choose the data to be encoded.
  *
  * @ingroup SmageApp
  *
  */
class SmageImgInputDlg : public QDialog
{
  Q_OBJECT

 public:

    SmageImgInputDlg(QWidget *topLevel=0);
    ~SmageImgInputDlg();

    // Open the dialog and get the user input
    static bool getTextInput(QString &textInput, QWidget *parent = 0, const char* name = 0);
    static bool getTextInput(const QString &textToShow, QString &textInput, QWidget *parent = 0, const char* name = 0);

  public slots:
    void okPressed();
    void cancelPressed();

 private:

    QPushButton *_okButton, *_cancelButton;
    QGridLayout *_gridLayout;
#ifdef SMAGE_DEMO
    QLineEdit *_lineEdit;
#else
    QTextEdit *_textEdit;
#endif

    QGroupBox *_textGroupBox;
    QString _textInput;
};

#endif
