#ifndef _SMAGE_IMG_SELECT_COPY_WIDGET_H
#define _SMAGE_IMG_SELECT_COPY_WIDGET_H

// project header
#include "SmageImgSelectionWidget.h"

typedef void TheS_SelectCopy_OpenImgCB(void *, const SmageSelectionType &, const bool &);
typedef void TheS_SelectCopyImgCB(void *, const QImage*, const QPointArray &);

/** Class SmageImgSelectCopyWidget contains the image a user can interact with.
  *
  * @ingroup SmageApp
  *
  * Image in which regions can be selected and copied into another widget
  */
class SmageImgSelectCopyWidget : public SmageImgSelectionWidget
{
  Q_OBJECT

    typedef SmageImgSelectionWidget inherited;

 public:
  
    SmageImgSelectCopyWidget(QWidget *parent, const char* name, WFlags f);
    ~SmageImgSelectCopyWidget();

    virtual QString getWidgetType() const { return QString("SMAGE_SELECT_COPY_WIDGET"); }    
    
    void grabPart();

    void selectAutoPoly();

    // Setting a number of callback functions
    void setOpenImgCB(void *userData, TheS_SelectCopy_OpenImgCB *f)
      { _openImgCBFunc = f; _openImgUserData = userData; }
    void setSelCopyImgCB(void *userData, TheS_SelectCopyImgCB *f)
      { _selCopyImgCBFunc = f; _selCopyImgUserData = userData; }

 protected:
    virtual void paintEvent(QPaintEvent *event);
    virtual void mousePressEvent(QMouseEvent *event);
    virtual void mouseReleaseEvent(QMouseEvent *event);
    virtual void mouseMoveEvent(QMouseEvent *event);

    /** Class specific operations when an image has been successfully loaded
      */
    virtual void doWhenSuccesImgLoading();

    virtual void incrementRegionID(){};

    // Set callback functions and class instances
    TheS_SelectCopy_OpenImgCB *_openImgCBFunc;
    void *_openImgUserData;
    TheS_SelectCopyImgCB *_selCopyImgCBFunc;
    void *_selCopyImgUserData;

    bool _waitForClick;
};

#endif
