/** Class SmageImgSnip shows parts of an image that have been selected and are to be integrated into another image widget
  *
  * @ingroup SmageApp
  *
  */
#ifndef _SMAGE_IMG_SNIP_H
#define _SMAGE_IMG_SNIP_H

// project header
#include "../smageSharedFiles/SmageConfig.h"

// qt header
#include <qimage.h>
#include <qpointarray.h>
#include <qwidget.h>


class SmageImgSnip : public QWidget
{
  Q_OBJECT

 public:

    SmageImgSnip(QWidget *parent, const char* name, const QPoint &parentImgStartPos, const QSize &parentImgSize,
	       WFlags f);
    ~SmageImgSnip();

    bool setImg(const QImage *img, const QPointArray &points, const QPoint &pos, const bool &sameSize);
    void getImgData(QImage &img, QPointArray &regionPoints) 
      { img = _img; regionPoints = _imgRegionPoints; }

    void setParentImgStartPos(const QPoint &pos) { _parentImgStartPos = pos; } 

 protected:
    virtual void mousePressEvent(QMouseEvent *event);
    virtual void mouseMoveEvent(QMouseEvent *event);
    virtual void mouseReleaseEvent(QMouseEvent *event);

    void verifyRegionPoints(QPointArray &points);

    QImage _img;
    QPointArray _imgRegionPoints;
    QRegion _imgRegion;
    QPoint _pressedPos, _parentImgStartPos;
    QSize _parentImgSize;
};

#endif
