// project header
#include "SmageMsgDlg.h"

// qt header
#include <qlabel.h>
#include <qlayout.h>
#include <qpushbutton.h>

// c/c++ header
#include <iostream>
#include <stdlib.h>

using namespace std;

SmageMsgDlg::SmageMsgDlg(QWidget *topLevel, const QString &caption, const QString &label,
			 const QString &b1, const int &defaultB, const QString &b2, const QString &b3)
  : QDialog(topLevel, 0)
{
  setCaption(caption);
  _whichButton = 0;

  int numCols = 3;
  if (!b2.isEmpty()) numCols++;
  if (!b3.isEmpty()) numCols++;

  _gridLayout = new QGridLayout(this, 2, numCols, 20);

  QLabel *theLabel = new QLabel(this);
  theLabel->setGeometry(10, 30, 400, 150);
  theLabel->setText(label);

  _gridLayout->addMultiCellWidget(theLabel, 0, 0, 0, numCols-1, Qt::AlignHCenter);

  _button1 = new QPushButton(b1, this);
  connect(_button1, SIGNAL(clicked()), this, SLOT(b1Pressed()));
  _button1->setFixedSize(90, 40);
  _gridLayout->addWidget(_button1, 1, 1, Qt::AlignHCenter); 

  _button2 = NULL;
  _button3 = NULL;

  if (!b2.isEmpty())
    {
      _button2 = new QPushButton(b2, this);
      connect(_button2, SIGNAL(clicked()), this, SLOT(b2Pressed()));
      _button2->setFixedSize(90, 40);
      _gridLayout->addWidget(_button2, 1, 2, Qt::AlignHCenter); 
    }

  if (!b3.isEmpty())
    {
      _button3 = new QPushButton(b3, this);
      connect(_button3, SIGNAL(clicked()), this, SLOT(b3Pressed()));
      _button3->setFixedSize(90, 40);
      _gridLayout->addWidget(_button3, 1, 3, Qt::AlignHCenter); 
    }  

  if (defaultB == 1)
    _button1->setDefault(TRUE);
  else if (defaultB == 2 && !b2.isEmpty())
    _button2->setDefault(TRUE);
  else if (defaultB == 3 && !b3.isEmpty())
    _button3->setDefault(TRUE);
  else
    _button1->setDefault(TRUE);
}


SmageMsgDlg::~SmageMsgDlg() 
{   
}


void SmageMsgDlg::b1Pressed()
{
  _whichButton = 1;
  accept();
}

void SmageMsgDlg::b2Pressed()
{
  _whichButton = 2;
  accept();
}

void SmageMsgDlg::b3Pressed()
{
  _whichButton = 3;
  accept();
}


bool SmageMsgDlg::getResult(int &whichButton, QWidget *parent, const QString &caption, const QString &label,
			    const QString &b1, const int &defaultB, const QString &b2, const QString &b3)
{
  SmageMsgDlg *dlg = new SmageMsgDlg(parent, caption, label, b1, defaultB, b2, b3);
  bool returnValue = FALSE;

  if (dlg->exec() == QDialog::Accepted)
  {
    whichButton = dlg->_whichButton;
    returnValue = TRUE;
  }
  
  delete dlg;
  return returnValue;
}
