#ifndef _SMAGE_TEXT_TYPE_DLG_H
#define _SMAGE_TEXT_TYPE_DLG_H

// project header
#include "../smageSharedFiles/SmageConfig.h"
#include <SmageObjShape.h>

// qt header
#include <qdialog.h>
class QPushButton;
class QGridLayout;

/** Class SmageTextTypeDlg: Dialog in which a user can choose the type of text to be encoded.
  *
  * @ingroup SmageApp
  *
  */
class SmageTextTypeDlg : public QDialog
{
  Q_OBJECT

 public:

    SmageTextTypeDlg(QWidget *topLevel=0);
    ~SmageTextTypeDlg();

    // Open the dialog and get the user input
    static bool getTextType(TextShapeType &textType, QWidget *parent = 0);
    
  public slots:
    void okPressed();
    void cancelPressed();
    void textType(int type);

 private:

    QPushButton *_okButton, *_cancelButton;
    QGridLayout *_gridLayout;

    TextShapeType _textType;
};

#endif
