//  There may be linker problems (Win 98 SE, Visual Studio 6):
//
//  projekt -> einstellungen -> reiter c/c++ -> kategorie: code generation
//  Single-Threaded zu Multithreaded DLL ndern

// project header
#include "SmageApp.h"
#include "../smageSharedFiles/SmageXmlConfigFileParser.h"

// qt header
#include <qapplication.h>
#include <qtranslator.h>


extern SmageConfig __smageConfig;

int main(int argc, char *argv[])
{
  QApplication::setColorSpec(QApplication::ManyColor);
  QApplication qAppl(argc, argv);
  
  // get users program configuration
  SmageXmlConfigFileParser configFileParser;
  

  char *d = getenv("SMAGE_DIR");
  QString smageDir ="";
  if ( d != NULL ) smageDir = QString( d );

  QTranslator translator( 0 );
  translator.load( smageDir + "smage_" + __smageConfig._language, "." );
  qAppl.installTranslator( &translator );  

  
  SmageApp *app = new SmageApp(0, argc, argv);
  qAppl.setMainWidget(app);

  app->show();

  QObject::connect(&qAppl, SIGNAL(lastWindowClosed()), &qAppl, SLOT(quit()));

  int returnValue = qAppl.exec();
  
  delete app;
  return returnValue;
}


/*
#include "TestWidget.h"

int main( int argc, char **argv )
{
  QApplication a( argc, argv );
  TestWidget drawB;
  a.setMainWidget( &drawB );
  drawB.show();
  return a.exec();
}
*/
